<?php
/*
Plugin Name: myWeather
Version: 2.3.1
Plugin URI: http://www.thedeveloperinside.com/blog/myweather-20-released
Author: Eduardo
Author URI: http://www.thedeveloperinside.com/
Description: Shows current weather conditions for your city by weather.com

1. Download
2. Upload this folder to your wp-plugins/ directory
4. Active the MyWeather Plugin in plugin administrate
5. Place this code in your template: 

"<?php wp_myweather();?>"

6. Use admin for select city:

 Contributors:
 ==============================================================================
 Developer              Eduardo      http://www.thedeveloperinside.com/
 Developer              alpinism     http://www.erata.net
 Xml Parser				minixml  	 http://

*/
$plugin_directory = get_option('home')."/wp-content/plugins/myweather/";

function get_cached_file(){
	if(get_option('wp_weather_xml')){
		return get_option('wp_weather_xml');
	}else{
		return false;
	}
}

function save_xml($file){
	if(get_option('wp_weather_xml')){
		update_option('wp_weather_xml',$file);
	}else{
		add_option('wp_weather_xml',$file,'myweather xml');
	}
}
function set_cache($n,$d){
	$f=@fopen($n,"w");
	if (!$f) {
		return false;
	} else {
		fwrite($f,$d);
		fclose($f);
		return true;
	}
}

function search_file_cached($wp_weather_xml){
	$plugin_directory=dirname(__FILE__)."/";
	$wp_weather_cache_temp=get_option('wp_weather_city_cache');
	$file=get_cached_file();
	if(is_file($plugin_directory."cache/".$file)){
		$ext=explode(".",$file);
		if(($ext[0]+$wp_weather_cache_temp)>time()){
			$xml=file_get_contents($plugin_directory."cache/".$file);
		}else{
			unlink($plugin_directory."cache/".$file);
			$xml=file_get_contents($wp_weather_xml);
			$file=time().".xml";
			set_cache($plugin_directory."cache/".$file,$xml);
			save_xml($file);
		}
	}else{
		$xml=file_get_contents($wp_weather_xml);
		$file=time().".xml";
		set_cache($plugin_directory."cache/".$file,$xml);
		save_xml($file);
	}
	return $xml;
}


function wp_myweather(){
	require_once(dirname(__FILE__).'/minixml/minixml.inc.php');
	global $plugin_directory;
	$city=get_option('wp_weather_city');
	$t_type=get_option('wp_weather_city_temp');
	$usedtemplate=get_option('wp_weather_template');
	if(!$t_type){
		$t_type="C";
	}
	$fdata = "http://xoap.weather.com/weather/local/".$city."?cc=*&dayf=0";
	
	
	$file=search_file_cached($fdata);
	
	$xmlObj = new MiniXMLDoc();

	
	$xmlObj->fromString($file);
	$xml = $xmlObj->getRoot();
	
	//print_r($xml->getElement('head')->getElement('locale'));

	
 	$template=array();

	$template['locale']=$xml->getElement('head')->getElement('locale')->getValue(); //lingua
	$template['form']=$xml->getElement('head')->getElement('form')->getValue(); //formato
	$template['ut']=$xml->getElement('head')->getElement('ut')->getValue(); //scala temperatura
	$template['ud']=$xml->getElement('head')->getElement('ud')->getValue(); //scala distanza
	$template['us']=$xml->getElement('head')->getElement('us')->getValue(); //scala velocita/tempo
	$template['up']=$xml->getElement('head')->getElement('up')->getValue(); //scala pressione
	$template['ur']=$xml->getElement('head')->getElement('ur')->getValue(); //
	$template['city']=$xml->getElement('loc')->getElement('dnam')->getValue(); //nome citta
	$template['time']=$xml->getElement('loc')->getElement('tm')->getValue(); //orario
	$template['lat']=$xml->getElement('loc')->getElement('lat')->getValue(); //latitudine
	$template['lon']=$xml->getElement('loc')->getElement('lon')->getValue(); //longitudine
	$template['suns']=$xml->getElement('loc')->getElement('suns')->getValue(); //alba
	$template['sunr']=$xml->getElement('loc')->getElement('sunr')->getValue(); //tramonto
	$template['zone']=$xml->getElement('loc')->getElement('zone')->getValue(); //zona
	$template['lsup']=$xml->getElement('cc')->getElement('lsup')->getValue(); //data rilevamento
	$template['obst']=$xml->getElement('cc')->getElement('obst')->getValue(); //osservatorio
	$template['tmp']=$xml->getElement('cc')->getElement('tmp')->getValue(); //temperatura
	$template['flik']=$xml->getElement('cc')->getElement('flik')->getValue(); //flik
	$template['weather']=$xml->getElement('cc')->getElement('t')->getValue(); //meteo
	$template['icon']=$xml->getElement('cc')->getElement('icon')->getValue(); //icona tempo
	$template['bar_r']=$xml->getElement('cc')->getElement('bar')->getElement('r')->getValue(); //pressione
	$template['bar_d']=$xml->getElement('cc')->getElement('bar')->getElement('d')->getValue(); //tipo pressione
	$template['wind_s']=$xml->getElement('cc')->getElement('wind')->getElement('s')->getValue(); //velocità vento
	$template['wind_gust']=$xml->getElement('cc')->getElement('wind')->getElement('gust')->getValue(); //raffica 
	$template['wind_d']=$xml->getElement('cc')->getElement('wind')->getElement('d')->getValue(); //
	$template['wind_t']=$xml->getElement('cc')->getElement('wind')->getElement('t')->getValue(); //direzione vento (N,S,E,W)
	$template['hmid']=$xml->getElement('cc')->getElement('hmid')->getValue(); //umidità in %
	$template['vis']=$xml->getElement('cc')->getElement('vis')->getValue(); //visibilità (distanza)
	$template['uv_i']=$xml->getElement('cc')->getElement('uv')->getElement('i')->getValue(); // raggi uv
	$template['uv_t']=$xml->getElement('cc')->getElement('uv')->getElement('t')->getValue(); // tipo raggi
	$template['dewp']=$xml->getElement('cc')->getElement('dewp')->getValue(); //Punto di rugiada (in temp)
	$template['moon_icon']=$xml->getElement('cc')->getElement('moon')->getElement('icon')->getValue(); //icona luna
	$template['moon_t']=$xml->getElement('cc')->getElement('moon')->getElement('t')->getValue(); //tipo luna
    
    list($template['city'])=explode(",",$template['city']);
	list($template['city'])=explode("/",$template['city']);
    
	switch($t_type){
		default:
		case "F":
			$template['tmp']=$template['tmp']."&deg;";
			break;
		case "C":
			$template['tmp']=round(($template['tmp']-32)/(1.8))."&deg;";
			break;
	}
    switch($template['icon']){
      default:
      case 44:
			$icon=0;
			break;
      case 5:
      case 8:
      case 9:
      case 11:
			$icon=1;
			break;
      case 15:
      case 25:
			$icon=2;
			break;
      case 20:
			$icon=3;
			break;
      case 32:
      case 36:
			$icon=4;
			break;
      case 19:
      case 21:
      case 22:
			$icon=5;
			break;
      case 0:
      case 1:
      case 2:
      case 3:
      case 4:
      case 17:
      case 35:
      case 37:
      case 38:
      case 47:
			$icon=6;
			break;
      case 39:
			$icon=7;
			break;
      case 13:
			$icon=8;
			break;
      case 23:
      case 24:
			$icon=9;
			break;
      case 14:
			$icon=10;
			break;
      case 14:
      case 16:
      case 18:
      case 41:
      case 42:
      case 43:
      case 46:
			$icon=11;
			break;
      case 10:
      case 12:
      case 40:
      case 45:
			$icon=12;
			break;
      case 26:
			$icon=13;
			break;
      case 6:
      case 7:
			$icon=14;
			break;
      case 28:
      case 30:
      case 34:
			$icon=15;
			break;
      case 27:
      case 29:
      case 31:
      case 33:
			$icon=16;
			break;
    }
    
    
    $template['icon']=$plugin_directory .'templates/'.$usedtemplate.'/icon/'.$icon.'.gif';
    
    
    
    $loadfile=file_get_contents(dirname(__FILE__).'/templates/'.$usedtemplate.'/template.html');
    foreach($template as $key=>$value){
    	$loadfile=str_replace('{'.strtoupper($key).'}',$value,$loadfile);

    }
    
	
	echo $loadfile;
}
function myweather_style() {
	global $plugin_directory;
	$usedtemplate=get_option('wp_weather_template');
	print('<link href="'.$plugin_directory.'templates/'.$usedtemplate.'/style.css" rel="stylesheet" type="text/css" />'."\n");
}
// Admin
function myweather_admin() {
	include("admin.myweather.php");
}
function myweather_to_admin() {
	if (function_exists('add_submenu_page')) {
		add_submenu_page('options-general.php', 'myWeather', 'myWeather', 1, basename(__FILE__), 'myweather_admin');
	}
}
add_action('admin_menu','myweather_to_admin');
add_action('wp_head', 'myweather_style', 10);

// widget
function widget_myweather_init() {
    if ( !function_exists('register_sidebar_widget') ){
            return;
    }
    register_sidebar_widget(array('myWeather', 'widgets'), 'widget_myweather');    
}

function widget_myweather($args){
    extract($args);
    echo $before_widget . $before_title . $title . $after_title;
    wp_myweather();
    echo $after_widget;
}
add_action('widgets_init', 'widget_myweather_init');

?>